#include <libtwo.h>
#include <libone.h>
#include <iostream.h>

#ifdef HAVE_MATH_H
#include <math.h>
#endif

// Our C functions.
int
foo(void)
{
  cout << "cos (0.0) = " << (double) cos ((double) 0.0) << endl;
  return FOO_RET;
}

int
hello(void)
{
  cout << "** This is libfoo (tagdemo) **" << endl;
  return HELLO_RET;
}

int two_global_int_var = 22;
void two_set_global_int_var (int new_value) { two_global_int_var = new_value; }

void copyval_two_direct_from_one ( void ) { 
  two_set_global_int_var( one_global_int_var );
}
void copyval_two_indirect_from_one ( void ) { 
  two_set_global_int_var( one_get_global_int_var() );
}
void copyval_one_direct_from_two ( void ) { 
  one_global_int_var = two_global_int_var;
}
void copyval_one_indirect_from_two ( void ) { 
  one_set_global_int_var( two_global_int_var );
}

// --------------------------------------------------------------------
// Our C++ derived class methods.


int
foobar_derived::foo(void)
{
  return ::foo();
}

int
foobar_derived::hello(void)
{
  return ::hello();
}
