#ifndef libtwo_h_included
#define libtwo_h_included

// Silly constants that the functions return.
#define HELLO_RET 0xe110
#define FOO_RET 0xf00

// Our C test functions.
extern "C"
{
  extern int foo(void);
  extern int hello(void);
  extern int two_global_int_var;
  extern void copyval_two_direct_from_one ( void );
  extern void copyval_two_indirect_from_one ( void ); 
  extern void copyval_one_direct_from_two ( void ); 
  extern void copyval_one_indirect_from_two ( void );
}

// Our test C++ base class.
class foobar
{
public:
  virtual int foo(void) = 0;
  virtual int hello(void) = 0;
  // Some dummy pure virtual functions.
};


// Our test C++ derived class.
class foobar_derived : public foobar
{
public:
  virtual int foo(void);
  virtual int hello(void);
  // Override the base class' pure virtual functions.
};

#endif /* libtwo_h_included */
